;; HTDP
;; Esercizio 14.2.2
;; &&
;; Esercizio 14.2.4

(define-struct node (soc pn l r))

(define elvira (make-node 10 'Elvira empty empty))
(define ennio (make-node 24 'Ennio empty empty))
(define lina (make-node 99 'Lina empty empty))
(define teresa (make-node 15 'Teresa elvira ennio))
(define paride (make-node 77 'Paride empty empty))
(define tina (make-node 95 'Tina empty lina))
(define giuseppe (make-node 29 'Giuseppe teresa empty))
(define patrizia (make-node 89 'Patrizia paride tina))
(define luca (make-node 63 'Luca giuseppe patrizia))

(define (search-bt numb atree)
  (cond
    [(empty? atree) false]
    [else
     (cond
       [(= numb (node-soc atree)) (node-pn atree)]
       [(symbol? (search-bt numb (node-l atree))) (search-bt numb (node-l atree))]
       [(symbol? (search-bt numb (node-r atree))) (search-bt numb (node-r atree))]
       [else false])]))

(define (search-bst numb atree)
  (cond
    [(empty? atree) false]
    [else
     (cond
       [(= numb (node-soc atree)) (node-pn atree)]
       [(< numb (node-soc atree)) (search-bst numb (node-l atree))]
       [(> numb (node-soc atree)) (search-bst numb (node-r atree))]
       [else false])]))